#include "USB1000AIContinuousAndDIO.h"
#include <QDebug>
#include <QElapsedTimer>
extern "C"{
#include "usb-1000.h"
}

void USB1000AIContinuousAndDIO(){
    qDebug()<<"/***************Test****************/";
    int temp;
    Q_UNUSED(temp);
    int DeviceIndex;
    int i;
    DeviceIndex = 0;	// 设定当前需要操作的设备索引号

    qDebug()<<"打开设备";
    temp = OpenDevice(DeviceIndex);					// 打开设备

    qDebug()<<"设备复位";
    temp = ResetDevice(DeviceIndex);				// 设备复位


    qDebug()<<"设置模拟输入量程";
    temp = SetUSB1AiRange(DeviceIndex, 5);	// 设置模拟输入量程

    qDebug()<<"设置模拟输入采样率";
    temp = SetSampleRate(DeviceIndex, 1000);	// 设置模拟输入采样率


    qDebug()<<"设置模拟输入通道连接方式";
    temp = SetChanMode(DeviceIndex, 1);		// 设置模拟输入通道连接方式，各种方式的硬件连接请参考手册


    qDebug()<<"选择需要采集的通道";
    temp = SetChanSel(DeviceIndex, 0x0005);		// 选择需要采集的通道

    qDebug()<<"设置Counter工作模式";
    temp = SetCounter(DeviceIndex, 0x0f, 0, 0x01);	// 设置Counter工作模式。如果不需要Counter工作，不用调用此函数

    qDebug()<<"启动Counter";
    temp = StartCounter(DeviceIndex, 0x0f, 1);		// 启动Counter。如果不需要Counter，不用调用此函数

    qDebug()<<"启动计算机从采集卡读数线程";
    temp = StartRead(DeviceIndex);					// 启动计算机从采集卡读数线程

    qDebug()<<"设置软件触发信号";
    temp = SetSoftTrig(DeviceIndex, 1);				// 设置软件触发信号


    float data[500000];
    unsigned int DIO_OUT;
    unsigned int DIO_IN;
    int DO[16];
    int DI[16];


    DIO_OUT = 0;
    for(i = 0; i < 16; i++)
    {
        DIO_OUT = DIO_OUT << 1;
        DIO_OUT = DIO_OUT + DO[15 - i];
    }

    qDebug()<<"设置DigitalOutput";
    temp = SetDioOut(DeviceIndex, DIO_OUT);		// 设置DigitalOutput


   qDebug()<<"读取DigitalInput";
    DIO_IN = GetDioIn(DeviceIndex);				// 读取DigitalInput
    for(i = 0; i < 16; i++)
    {
        DI[i] = DIO_IN & 0x01;
        DIO_IN = DIO_IN >> 1;
    }

    qDebug()<<"读取Counter值";
    uint CT[4];
    for(i = 0; i < 4; i++)
    {
        CT[i] = GetCounter(DeviceIndex, i);		// 读取Counter值
    }

    int AiFifoFree;

    qDebug()<<"读取模拟输入采集数据";
    // 读取模拟输入采集数据，返回值可查看AiFifo空间剩余数量
    // 如果AiFifoFree这个值越来越小，长时间数据采集则有数据溢出的风险
    // 假设每通道读取数据量为NumToRead=1000个，选择读取了3个通道，data数组中将读回3000个数据
    // 那么在data数组中，前1000个数是第一个通道数据，中间1000个数是第二个通道数据，后1000个数是第三个通道数据
    AiFifoFree = GetAiChans(DeviceIndex, 1000, 0x0005, data, 1000);


    qDebug()<<"关闭计算机从采集卡读数线程";
    temp = StopRead(DeviceIndex);					// 关闭计算机从采集卡读数线程

    qDebug()<<"关闭软件触发信号";
    temp = SetSoftTrig(DeviceIndex, 0);				// 关闭软件触发信号

    qDebug()<<"清空数据缓存空间";
    temp = ClearBufs(DeviceIndex);					// 清空数据缓存空间

    qDebug()<<"关闭Counter";
    temp = StartCounter(DeviceIndex, 0x0f, 0);		// 关闭Counter。如果不需要Counter，不用调用此函数
    qDebug()<<"关闭设备";
    CloseDevice(DeviceIndex);					// 关闭设备

    qDebug()<<"/***************End*****************/";
}

void delay_3(int msec){
    QElapsedTimer t;
    t.start();
    while(t.elapsed()<msec);
}
